import gtk, gobject

from cohoba.telepathy.ProtocolRegistry import get_protocol_registry

class ProtocolList(gtk.ListStore):
	COL_PROTOCOL = 0
	COL_MANAGER = 1
	COL_STRING = 2
	
	def __init__(self):
		gtk.ListStore.__init__(self, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
		self.protocols = {}
		
		protocols = get_protocol_registry().GetProtos()
		for protocol in protocols:
			self.protocols[protocol] = {}
			managers = get_protocol_registry().GetManagers(protocol)
			for manager in managers:
				iter = self.append([protocol, manager, "<b>%s</b> (%s)" % (protocol, manager)])
				self.protocols[protocol][manager] = gtk.TreeRowReference(self, self.get_path(iter))
	
	def get_protocol_iter(self, protocol, manager):
		if protocol != None and manager != None:
			return self.get_iter(self.protocols[protocol][manager].get_path())

		return None
