import gtk

from cohoba.ui.ConversationWindow import ConversationWindow
from cohoba.telepathy.TelepathyConversation import TelepathyConversation
from cohoba.telepathy.MergedContactList import get_contact_list

class ConversationWindowManager:
	def __init__(self):
		self.windows = {}
		
	def show(self, conn_path, obj_path, handle):
		if conn_path not in self.windows:
			self.windows[conn_path] = {}
			
		if handle not in self.windows[conn_path]:
			contact = get_contact_list().get_contact(conn_path, handle)
			conv = TelepathyConversation(conn_path, obj_path, contact)
			self.windows[conn_path][handle] = ConversationWindow(conv)
			conv.connect('closed', self.on_conversation_closed, conn_path, handle)
			

		self.windows[conn_path][handle].present_with_time(gtk.get_current_event_time())
		return self.windows[conn_path][handle]
	
	def on_conversation_closed(self, conversation, conn_path, handle):
		print 'Removing conversation'
		del self.windows[conn_path][handle]
		
	def show_existing(self, conn_path, handle):
		self.windows[conn_path][handle].present_with_time(gtk.get_current_event_time())
		return self.windows[conn_path][handle]
		
manager = ConversationWindowManager()
def get_conversation_window_manager():
	return manager	
	
