import gtk, gobject

from cohoba.telepathy.ProtocolList import ProtocolList
from cohoba.ui.ProtocolIcons import get_protocol_icons

class ProtocolComboBox(gtk.ComboBox):
	def __init__(self):
		gtk.ComboBox.__init__(self, ProtocolList())
		
		cell = gtk.CellRendererPixbuf()
		self.pack_start(cell, False)
		self.set_cell_data_func(cell, self.get_pixbuf_from_protocol)
		
		cell = gtk.CellRendererText()
		self.pack_start(cell, True)
		self.add_attribute(cell, 'markup', ProtocolList.COL_STRING)

	def get_pixbuf_from_protocol(self, layout, cell, model, iter):
		cell.set_property('pixbuf', get_protocol_icons().get_icon(model[iter][ProtocolList.COL_PROTOCOL]))
		
	def set_active_protocol(self, protocol, manager):	
		iter = self.get_model().get_protocol_iter(protocol, manager)
		if iter != None:
			self.set_active_iter(iter)	
	
	def get_active_protocol(self):
		iter = self.get_active_iter()
		if iter != None:
			return self.get_model()[iter][ProtocolList.COL_PROTOCOL], self.get_model()[iter][ProtocolList.COL_MANAGER]
		
		return None
